package com.hxhq.business.service.impl;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.hxhq.business.domain.Gyzj;
import com.hxhq.business.domain.GyzjJcgj;
import com.hxhq.business.domain.Mjy;
import com.hxhq.business.domain.MjyJcgj;
import com.hxhq.business.service.ISystemLogService;
import com.hxhq.business.utils.JctUtil;
import com.hxhq.business.utils.lang.GyzjJcnrUtil;
import com.hxhq.common.core.exception.ServiceException;
import com.hxhq.common.core.utils.StringUtils;
import com.hxhq.system.api.domain.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import com.hxhq.business.mapper.GyzjJcgjMapper;
import com.hxhq.business.service.IGyzjJcgjService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * -稽查轨迹Service业务层处理
 *
 * @author hxhq
 * @date 2025-12-18
 */
@Service
public class GyzjJcgjServiceImpl extends ServiceImpl<GyzjJcgjMapper, GyzjJcgj> implements IGyzjJcgjService
{

    @Autowired
    private ISystemLogService systemLogService;

    /**
     * 查询稽查轨迹列表
     * @param gyzjJcgj 麻给药
     * @return
     */
    @Override
    public List<GyzjJcgj> queryList(GyzjJcgj gyzjJcgj){
        QueryWrapper<GyzjJcgj> queryWrapper = Wrappers.query();
        if(gyzjJcgj.getGyzjId()==null||gyzjJcgj.getGyzjId().longValue()<0){
            throw new ServiceException("id不能为空");
        }
        queryWrapper.eq("gyzj_id",gyzjJcgj.getGyzjId());
        if(gyzjJcgj.getJcgjlx()!=null&&gyzjJcgj.getJcgjlx().intValue()>0){
            queryWrapper.eq("jcgjlx",gyzjJcgj.getJcgjlx());
        }
        if (StringUtils.isNoneBlank(gyzjJcgj.getJcmc())) {
            queryWrapper.and(p -> p.like("`jcmc`", gyzjJcgj.getJcmc())
                    .or().like("`jcnr`", gyzjJcgj.getJcmc()));
        }
        queryWrapper.orderByDesc("id");
        return this.list(queryWrapper);
    }

    /**
     * 批量保存稽查轨迹-并保留日志
     * @param jcgjList
     */
    @Override
    @Async
    public void saveBatchWithLog(List<GyzjJcgj> jcgjList) {
        this.saveBatch(jcgjList);
        for (GyzjJcgj jcgj : jcgjList) {
            systemLogService.saveInfo(jcgj.getGyzjBh(), jcgj.getGyzjBh(), jcgj.getJcmc(), jcgj.getJcmcEn(),
                    jcgj.getJcnr(), jcgj.getJcnrEn(), jcgj.getQmrId(), jcgj.getQmrMc(), jcgj.getQmrMcEn(), jcgj.getRemark());
        }
    }

    /**
     * 新增稽查轨迹
     * @param gyzj 给药制剂
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  void saveJcgj(Gyzj gyzj, Integer jcgjlx, String jcmc, Integer jcmcys, Map<String, String> jcnr, SysUser qmr, String remark){
        GyzjJcgj gyzjJcgj = new GyzjJcgj();
        gyzjJcgj.setGyzjId(gyzj.getId());
        gyzjJcgj.setGyzjBh(gyzj.getBh());
        gyzjJcgj.setJcgjlx(jcgjlx);
        gyzjJcgj.setJcmc(jcmc);
        gyzjJcgj.setJcmcEn(GyzjJcnrUtil.getEn(jcmc));
        gyzjJcgj.setJcmcys(jcmcys);
        if(jcnr!=null){
            gyzjJcgj.setJcnr(JctUtil.formatStr(jcnr));
            gyzjJcgj.setJcnrEn(GyzjJcnrUtil.getJcnrEn(jcnr));
        }
        if(qmr!=null) {
            gyzjJcgj.setQmrId(qmr.getUserId());
            gyzjJcgj.setQmrMc(qmr.getNickName());
            gyzjJcgj.setQmrMcEn(qmr.getUserName());
        }
        gyzjJcgj.setRemark(remark);
        this.save(gyzjJcgj);
        systemLogService.saveInfo(gyzj.getBh(), gyzj.getBh(), gyzjJcgj.getJcmc(), gyzjJcgj.getJcmcEn(),
                gyzjJcgj.getJcnr(), gyzjJcgj.getJcnrEn(), gyzjJcgj.getQmrId(), gyzjJcgj.getQmrMc(), gyzjJcgj.getQmrMcEn(), gyzjJcgj.getRemark());

    }

    /**
     * 新增稽查轨迹
     * @param gyzj 给药制剂
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  GyzjJcgj getJcgj(Gyzj gyzj, Integer jcgjlx, String jcmc, Integer jcmcys, Map<String, String> jcnr, SysUser qmr, String remark){
        GyzjJcgj gyzjJcgj = new GyzjJcgj();
        gyzjJcgj.setGyzjId(gyzj.getId());
        gyzjJcgj.setGyzjBh(gyzj.getBh());
        gyzjJcgj.setJcgjlx(jcgjlx);
        gyzjJcgj.setJcmc(jcmc);
        gyzjJcgj.setJcmcEn(GyzjJcnrUtil.getEn(jcmc));
        gyzjJcgj.setJcmcys(jcmcys);
        if(jcnr!=null){
            gyzjJcgj.setJcnr(JctUtil.formatStr(jcnr));
            gyzjJcgj.setJcnrEn(GyzjJcnrUtil.getJcnrEn(jcnr));
        }
        if(qmr!=null) {
            gyzjJcgj.setQmrId(qmr.getUserId());
            gyzjJcgj.setQmrMc(qmr.getNickName());
            gyzjJcgj.setQmrMcEn(qmr.getUserName());
        }
        gyzjJcgj.setRemark(remark);
        return  gyzjJcgj;
    }

    /**
     * 新增稽查轨迹
     * @param gyzj 给药制剂
     * @param jcgjlx 稽查轨迹类型:1:流程；3：编辑
     * @param jcmc 稽查名称
     * @param jcmcys 稽查名称颜色：1：蓝色；3：红色；5：绿色；7：橙色
     * @param jcnr 稽查内容
     * @param jcnrEn 稽查内容英文
     * @param qmr 签名人
     * @param remark 备注
     */
    @Override
    public  GyzjJcgj getJcgj(Gyzj gyzj,Integer jcgjlx, String jcmc, Integer jcmcys, String jcnr,String jcnrEn, SysUser qmr, String remark){
        GyzjJcgj gyzjJcgj = new GyzjJcgj();
        gyzjJcgj.setGyzjId(gyzj.getId());
        gyzjJcgj.setGyzjBh(gyzj.getBh());
        gyzjJcgj.setJcgjlx(jcgjlx);
        gyzjJcgj.setJcmc(jcmc);
        gyzjJcgj.setJcmcEn(GyzjJcnrUtil.getEn(jcmc));
        gyzjJcgj.setJcmcys(jcmcys);
        gyzjJcgj.setJcnr(jcnr);
        gyzjJcgj.setJcnrEn(jcnrEn);
        if(qmr!=null) {
            gyzjJcgj.setQmrId(qmr.getUserId());
            gyzjJcgj.setQmrMc(qmr.getNickName());
            gyzjJcgj.setQmrMcEn(qmr.getUserName());
        }
        gyzjJcgj.setRemark(remark);
        return  gyzjJcgj;
    }

}
